<?php

namespace DigitalPoint\Cloudflare\Job;

use XF\Job\AbstractJob;

class PurgeCache extends AbstractJob
{
	public function run($maxRunTime)
	{
		if (!empty($this->data['urls']))
		{
			/** @var \DigitalPoint\Cloudflare\Repository\Cloudflare $cloudflareRepo */
			$cloudflareRepo = $this->app->repository('DigitalPoint\Cloudflare:Cloudflare');
			$cloudflareRepo->purgeCache(['files' => $this->data['urls']]);
		}

		return $this->complete();
	}

	public function getStatusMessage()
	{
		return \XF::phrase('purging_cache');
	}

	public function canCancel()
	{
		return false;
	}

	public function canTriggerByChoice()
	{
		return false;
	}
}