<?php

namespace DigitalPoint\Cloudflare\Listener;
class AppPubComplete
{
	public static function run(\XF\Pub\App $app, \XF\Http\Response &$response)
	{

		if (
			\XF::options()->cfMediaCachingSeconds &&
			$app->container('app.classType') === 'Pub' &&
			(substr($app->request()->getRoutePath(), 0, 11) === 'attachments' || substr($app->request()->getRoutePath(), 0, 5) === 'media') && // Could be an issue if a site used route filters to change the default route
			$app->response()->httpCode() == 200 &&
			in_array(substr($app->response()->contentType(), 0, 6), ['image/', 'video/', 'audio/'])
		)
		{
			$response->header('Expires', gmdate('D, d M Y H:i:s', \XF::$time + \XF::options()->cfMediaCachingSeconds) . ' GMT');
			$response->header('Cache-control', 'public,max-age=' . \XF::options()->cfMediaCachingSeconds);
		}
		elseif ($app->templater()->canEdgeCache())
		{
			$response->header('Expires', gmdate('D, d M Y H:i:s', \XF::$time + \XF::options()->cfPageCachingSeconds) . ' GMT');
			$response->header('Cache-control', 'max-age=0,s-maxage=' . \XF::options()->cfPageCachingSeconds);
		}
		elseif (\XF::visitor()->user_id && \XF::options()->cfPageCachingSeconds && \XF::app()->response()->contentType() === 'text/html')
		{
			$response->removeHeader('Last-Modified');
		}
	}
}