<?php

namespace DigitalPoint\Cloudflare\Option;

use XF\Option\AbstractOption;

class Auth extends AbstractOption
{
	public static function renderOption(\XF\Entity\Option $option, array $htmlParams): string
	{
		if (!empty(\XF::options()->cloudflareAuth['token']))
		{
			try {
				$tokenId = \XF::repository('DigitalPoint\Cloudflare:Cloudflare')->verifyToken();
				if (!is_string($tokenId))
				{
					$tokenId = null;
				}
			}
			catch(\Exception $e)
			{
				$tokenId = null;
			}
		}
		else
		{
			$tokenId = null;
		}

		return self::getTemplate('admin:option_template_cloudflareAuth', $option, $htmlParams, [
			'tokenId' => $tokenId,
		]);
	}
}