<?php

namespace DigitalPoint\Cloudflare\Traits\Repository;

trait XF
{
	/**
	 * @return array
	 */
	protected function getAdminEmails()
	{
		$admins = $this->repository('XF:Admin')->findAdminsForList();

		$emails = [];
		foreach ($admins as $admin)
		{
			if ($admin->User->email)
			{
				$emails[] = ['email' => ['email' => $admin->User->email]];
			}
		}

		return $emails;
	}

	/**
	 * @return array
	 */
	protected function getAdminAreas($include = '')
	{
		return [
			'/admin.php' => $this->phrase('xenforo_admin'),
			'/install' => $this->phrase('xenforo_install')
		];
	}


	protected function addCron($jobKey, $expireDays, $id)
	{
		$jobManager = $this->app()->jobManager();
		$jobManager->enqueueLater($jobKey, \XF::$time + (86400 * $expireDays), 'DigitalPoint\Cloudflare\Job\FirewallRuleDelete', ['id' => $id], false);
	}
	protected function cancelCron($jobKey)
	{
		$jobManager = $this->app()->jobManager();
		$jobManager->cancelUniqueJob($jobKey);
	}
}