<?php

namespace DigitalPoint\Cloudflare\XF\Pub\View\SpamCleaner;

class CheckIps extends XFCP_CheckIps
{
	public function renderJson()
	{
		if (\XF::visitor()->canViewIps() && \XF::app()->request()->filter('block_ips', 'bool'))
		{
			$ips = \XF::app()->repository('XF:Ip')->getIpsByUser($this->params['spammer']);

			if ($ips)
			{
				/** @var \DigitalPoint\Cloudflare\Repository\Cloudflare $cloudflareRepo */
				$cloudflareRepo = \XF::app()->repository('DigitalPoint\Cloudflare:Cloudflare');

				foreach ($ips as $ip)
				{
					if ($ip['last_date'] + (30 * 86400) > \XF::$time)
					{
						$cloudflareRepo->addFirewallAccessRule(
							\XF\Util\Ip::convertIpBinaryToString($ip['ip']),
							0,
							'',
							'block',
							\XF::phrase('used_by_spammer_x', ['user' => $this->params['spammer']->username]),
							\XF::options()->cloudflareFirewallExpireDays
						);
					}
					else
					{
						// Now into IPs that haven't been used in the last 30 days.
						break;
					}
				}
			}
		}

		if (method_exists(get_parent_class($this), 'renderJson'))
	//	if (is_callable('parent::renderJson'))
		{
			parent::renderJson();
		}
	}
}

// ******************** FOR IDE AUTO COMPLETE ********************
if (false)
{
	class XFCP_CheckIps extends \XF\Pub\View\SpamCleaner\CheckIps {}
}